/*
	sdgetfrc.c

	% sed_GetFieldRow, sed_GetFieldCol, sed_GetFieldLastCol

	C-scape 3.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	12/16/88 jmd	turned into functions

	 3/24/89 jmd	added sed_ macros

	 3/28/90 jmd	ansi-fied
*/

#include "sed.h"

int sed_GetFieldRow(sed_type sed, int fieldno)
/*
	Returns the row location of the field.
	The row is in display coordinates.
*/
{
  	return (menu_GetFieldRow(sed_GetMenu(sed), fieldno) + 
			win_GetTopRow(sed) - sed_GetYoffset(sed));
}

int sed_GetFieldCol(sed_type sed, int fieldno)
/*
	Returns the column location of the field.
	The column is in display coordinates.
*/
{
  	return (menu_GetFieldCol(sed_GetMenu(sed), fieldno) + 
			win_GetLeftCol(sed) - sed_GetXoffset(sed));
}

int sed_GetFieldLastCol(sed_type sed, int fieldno)
/*
	Returns the last column location of the field.
	The location is in display coordinates.
*/
{
  	return (menu_GetFieldLastCol(sed_GetMenu(sed), fieldno) + 
			win_GetLeftCol(sed) - sed_GetXoffset(sed));
}

