/*
	sdgetpos.c

	% sed_GetPosition

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/18/87 jmd	Changed name of file for consistency.
	 7/07/88 jmd	added windows
	 8/15/88 jmd	made work with new borders
	11/15/88 jmd	made work with newest borders

	 2/07/89 jmd	Removed bordobj.h

	 3/28/90 jmd	ansi-fied
*/

#include "sed.h"

void sed_GetPosition(sed_type sed, int *rowmin, int *colmin)
/*
	effects:	returns the position of the sed into the
				locations pointed to by row and col.
				if there is a border (unfixed) then its position is returned
*/
{
	cs_Assert(sed_Ok(sed), CS_SD_GP_SED, 0);

	*rowmin = bord_GetTopRow(sed);
	*colmin = bord_GetLeftCol(sed);
}
