/*
	sdgtfclr.c

	% sed_GetFieldColors

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/24/89 jmd	added sed_ macros
	 4/13/89 jmd	added sed_GetField macro

	 3/28/90 jmd	ansi-fied
*/

#include "sed.h"

void sed_GetFieldColors(sed_type sed, int fieldno, byte *reg, byte *sel)
/*
	Get the regular and select colors for a field.
	If the field is UnMarked get the colors for the sed.
*/
{
	field_type field;

	cs_Assert(sed_Ok(sed), CS_SD_GFC_SED, 0);
	cs_Assert(reg != NULL && sel != NULL, CS_SD_GFC_PTR, 0);

	field = sed_GetField(sed, fieldno);

	if (field_GetMarked(field)) {
		*reg = field_GetRegAttr(field);
		*sel = field_GetSelAttr(field);
	}
	else {
		*reg = sed_GetRegAttr(sed);
		*sel = sed_GetSelAttr(sed);
	}
}


