/*
	sdpulllt.c

	% sed_PullRight

	C-scape 3.2
	Copyright (c) 1986, 1987, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	11/06/86 jmd	Now returns the deleted character.
	11/14/86 sng	Now handles variable-length fields.
	11/18/87 jmd 	changed names of some low-level funcs
	 5/11/88 jmd 	moved work to field_PullRight

	 3/24/89 jmd	added sed_ macros

	 3/28/90 jmd	ansi-fied
*/					

#include "sed.h"
#include "fldpriv.h"

char sed_PullRight(sed_type sed)
/*
	modifies:   the sed.
	effects:    deletes the current character, pulls in the characters to the
				right:
				|heello mom   |
				   ^ 
				|hello mom    |
				   ^
	returns:	the deleted character.  If the cursor is over empty area,
 				return '\0'.
*/
{
	char del_char;

	cs_Assert(sed_Ok(sed), CS_SD_PULR_SED, 0);

	/* Remember the deleted character. */
	del_char = menu_PullRight(sed_GetMenu(sed), sed_GetFieldNo(sed), sed_GetRecordPos(sed));

	if (del_char != '\0') {
		sd_refresh_field(sed, sed_GetFieldNo(sed));
	}

	return(del_char);
}
