/*
	spcabort.c

	% spc_Abort

	special_key function.

	Traps ESCAPE and sets baton to SED_ABORT.

	C-scape 3.2
	Copyright (c) 1988, by Oakland Group, Inc.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 3/28/90 jmd	ansi-fied
*/

#include <stdio.h>

#include "cscape.h"
#include "scancode.h"

boolean spc_Abort(sed_type sed, int scancode)
/*
	Sets baton to SED_ABORT and exits the sed when ESC is pressed.
*/
{
	if (scancode == ESC) {
		sed_SetBaton(sed, SED_ABORT);
		sed_ToggleExit(sed);
		return(TRUE);
	}

	return(FALSE);
}

